#include <Servo.h>
#include <SoftwareSerial.h>  //import serial library
#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
#include <avr/power.h> 
#endif

#define TxD 11
#define RxD 10

Adafruit_NeoPixel pixels(12, 4, NEO_GRB + NEO_KHZ800);
SoftwareSerial bluetoothSerial(TxD, RxD);

Servo base;
Servo gear;
Servo wrist;
Servo dome;

int aG = 90;
int aB = 90;
int aW = 90;
int aD = 90;

int i = 0;

char blueToothVal;  //data for bluetooth 
char c;



int moveTo(int aBase, int aGear, int aWrist, int aDome, int stepDelay) {
       
    for (i = 0;i<=180;i++) {
      
    if (aBase > aB+5){
    base.write(aB + 1);
    aB = (aB + 1);
    }

    if (aBase < aB-5){
    base.write(aB - 1);
    aB = (aB - 1);
    }

   
    if (aGear > aG+5){
    gear.write(aG + 1);
    aG = (aG + 1);
    }

    if (aGear < aG-5){
    gear.write(aG - 1);
    aG = (aG - 1);
    }


    if (aWrist > aW+5){
    wrist.write(aW + 1);
    aW = (aW + 1);
    }
    
    if (aWrist < aW-5){
    wrist.write(aW - 1);
    aW = (aW - 1);
    }

    
    if (aDome > aD+5){
    dome.write(aD + 1);
    aD = (aD + 1);
    }
    
    if (aDome < aD-5){
    dome.write(aD - 1);
    aD = (aD - 1);
    }
    
    delay(stepDelay);
    }
        
}

void searching() {
  home();
  for(int i=0; i<12; i++) 
  {
    pixels.setPixelColor(i, pixels.Color(255, 255, 255));  //blue
    pixels.setPixelColor(i-1, pixels.Color(150, 150, 150));  //blue
    pixels.setPixelColor(i-2, pixels.Color(30, 30, 30));  //blue
    pixels.show();
    pixels.setPixelColor(i, pixels.Color(0, 0, 0));  //blue
    pixels.setPixelColor(i-1, pixels.Color(0, 0, 0));  //blue
    pixels.setPixelColor(i-2, pixels.Color(0, 0, 0));  //blue
    delay(100);
  }
}

void error() {
  pixels.clear();
  for(int i=0; i<12; i++) 
  {
    pixels.setPixelColor(i, pixels.Color(255, 0, 0));
    pixels.setPixelColor(i-1, pixels.Color(150, 0, 0));
    pixels.setPixelColor(i-2, pixels.Color(30, 0, 0));
    pixels.show();
    pixels.setPixelColor(i, pixels.Color(0, 0, 0));
    pixels.setPixelColor(i-1, pixels.Color(0, 0, 0));
    pixels.setPixelColor(i-2, pixels.Color(0, 0, 0));
    delay(100);
  }
}

void on(){
    for(int i=0; i<12; i++) {
    pixels.setPixelColor(i, pixels.Color(255, 255, 255));
    pixels.show();
    }
  }


void off(){
    for(int i=0; i<12; i++) {
    pixels.setPixelColor(i, pixels.Color(0, 0, 0));
    pixels.show();
    }

    delay(20000);

    on();
  }


void home(){
  moveTo(30, 90, 80, 130, 10);
}

void angry(){
    for(int i=0; i<12; i++) {
    pixels.setPixelColor(i, pixels.Color(255, 0, 0));
    pixels.show();
    }
    moveTo(145, 120, 120, 120, 5);
    delay(20);
    moveTo(45, 120, 120, 120, 5);
    delay(20);
    moveTo(145, 120, 120, 120, 5);
    delay(20);
    moveTo(45, 120, 120, 120, 5);
    delay(20);
    home();
  }

void curious(){
  for(int i=0; i<12; i++) {
    pixels.setPixelColor(i, pixels.Color(255, 0, 255));
    pixels.show();
    }
    moveTo(90, 0, 145, 120, 5);
    delay(5000);
    moveTo(90, 0, 145, 90, 5);
    delay(1000);
    moveTo(90, 0, 145, 60, 5);
    delay(20);
    home();
  }

void happy(){

  moveTo(90, 70, 110, 120, 10);
  
  pixels.clear();

  pixels.setPixelColor(2, pixels.Color(255, 255, 0));
  pixels.setPixelColor(0, pixels.Color(255, 255, 0));

  pixels.setPixelColor(5, pixels.Color(255, 255, 0));
  pixels.setPixelColor(6, pixels.Color(255, 255, 0));
  pixels.setPixelColor(7, pixels.Color(255, 255, 0));
  pixels.setPixelColor(8, pixels.Color(255, 255, 0));
  pixels.setPixelColor(9, pixels.Color(255, 255, 0));
  pixels.show();

  moveTo(90, 70, 110, 70, 10);

  delay(300);
  
  moveTo(90, 70, 110, 110, 10);

  delay(300);

  moveTo(90, 70, 110, 70, 10);
  
  delay(5000);

  home();

  }

void sad(){

  pixels.clear();

  pixels.setPixelColor(6, pixels.Color(0, 0, 180));
  pixels.setPixelColor(8, pixels.Color(0, 0, 180));

  pixels.setPixelColor(11, pixels.Color(0, 0, 180));
  pixels.setPixelColor(0, pixels.Color(0, 0, 180));
  pixels.setPixelColor(1, pixels.Color(0, 0, 180));
  pixels.setPixelColor(2, pixels.Color(0, 0, 180));
  pixels.setPixelColor(3, pixels.Color(0, 0, 180));
  pixels.show();


  moveTo(90, 70, 110, 120, 20);

  delay(2000);

  moveTo(90, 70, 110, 60, 40);

  delay(100);

  moveTo(90, 30, 50, 120, 40);

  delay(300);
  
  moveTo(90, 30, 50, 130, 30);

  delay(300);

  moveTo(90, 30, 50, 70, 20);
  
  delay(5000);

  home();

  }


void setup() {
  moveTo(90, 90, 70, 90, 20);
  bluetoothSerial.begin(9600);
  base.attach(0);
  gear.attach(1);
  wrist.attach(2);
  dome.attach(3);
  home();

  

#if defined(__AVR_ATtiny85__) && (F_CPU == 16000000)
  clock_prescale_set(clock_div_1);
#endif

pixels.begin();
}


void loop() {

  if(bluetoothSerial.available()){ 
    c = bluetoothSerial.read();   //read received data
    if (c =='1') {
      
      happy();
         
    }

    if (c =='2') {
      
      sad();
         
    }

    if (c =='3') {
      
      angry();
         
    }

    if (c =='4') {
      
      curious();
         
    }

    if (c =='5') {
      
      off();
         
    }

    else {
      on();
      }
  
  }

  else{
    on();
    }
}
